package org.springblade.core.redis.cache;

import org.springframework.lang.Nullable;

import java.time.Duration;

/**
 * Author pangqijun
 * Date 2023/10/24
 * Description
 */
public class CacheKey {
	private final String key;
	@Nullable
	private Duration expire;

	public CacheKey(String key) {
		this.key = key;
	}

	public String getKey() {
		return this.key;
	}

	@Nullable
	public Duration getExpire() {
		return this.expire;
	}

	public String toString() {
		return "CacheKey(key=" + this.getKey() + ", expire=" + this.getExpire() + ")";
	}

	public CacheKey(final String key, @Nullable final Duration expire) {
		this.key = key;
		this.expire = expire;
	}
}
