package org.springblade.core.redis.cache;

import org.springblade.core.tool.utils.ObjectUtil;
import org.springblade.core.tool.utils.StringUtil;
import org.springframework.lang.Nullable;

import java.time.Duration;

/**
 * Author pangqijun
 * Date 2023/10/24
 * Description
 */
public interface ICacheKey {
	String getPrefix();

	@Nullable
	default Duration getExpire() {
		return null;
	}

	default CacheKey getKey(Object... suffix) {
		String prefix = this.getPrefix();
		String key;
		if (ObjectUtil.isEmpty(suffix)) {
			key = prefix;
		} else {
			key = prefix.concat(StringUtil.join(suffix, ":"));
		}

		Duration expire = this.getExpire();
		return expire == null ? new CacheKey(key) : new CacheKey(key, expire);
	}
}
