package org.springblade.core.sms;

import org.springblade.core.sms.model.SmsCode;
import org.springblade.core.sms.model.SmsData;
import org.springblade.core.sms.model.SmsInfo;
import org.springblade.core.sms.model.SmsResponse;
import org.springblade.core.tool.utils.RedisUtil;
import org.springblade.core.tool.utils.StringUtil;
import org.springframework.util.StringUtils;

import java.util.Collection;
import java.util.Collections;
import java.util.concurrent.TimeUnit;

/**
 * Author pangqijun
 * Date 2023/10/20
 * Description smsTemplate
 */
public interface SmsTemplate {

	default String cacheKey(String phone, String id) {
		return "blade:sms::captcha:" + phone + ":" + id;
	}

	default boolean send(SmsInfo smsInfo) {
		return this.sendMulti(smsInfo.getSmsData(), smsInfo.getPhones());
	}

	default boolean sendSingle(SmsData smsData, String phone) {
		return StringUtils.isEmpty(phone) ? Boolean.FALSE : this.sendMulti(smsData, Collections.singletonList(phone));
	}

	default boolean sendMulti(SmsData smsData, Collection<String> phones) {
		SmsResponse response = this.sendMessage(smsData, phones);
		return response.isSuccess();
	}

	SmsResponse sendMessage(SmsData smsData, Collection<String> phones);

	SmsCode sendValidate(SmsData smsData, String phone);

	boolean validateMessage(SmsCode smsCode);
}
