package org.springblade.core.sms.config;

import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.IAcsClient;
import com.aliyuncs.profile.DefaultProfile;
import com.aliyuncs.profile.IClientProfile;
import org.springblade.core.sms.AliSmsTemplate;
import org.springblade.core.sms.props.SmsProperties;
import org.springblade.core.tool.utils.RedisUtil;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * Author pangqijun
 * Date 2023/10/20
 * Description
 */
@Configuration(
	proxyBeanMethods = false
)
@ConditionalOnClass({IAcsClient.class})
@EnableConfigurationProperties({SmsProperties.class})
@ConditionalOnProperty(
	value = {"sms.name"},
	havingValue = "aliyun"
)
public class AliSmsConfiguration {

	@Bean
	public AliSmsTemplate aliSmsTemplate(SmsProperties smsProperties, RedisUtil redisUtil) {
		IClientProfile profile = DefaultProfile.getProfile(smsProperties.getRegionId(), smsProperties.getAccessKey(), smsProperties.getSecretKey());
		IAcsClient acsClient = new DefaultAcsClient(profile);
		return new AliSmsTemplate(smsProperties, acsClient, redisUtil);
	}
}
